/* AMX Mod X
*   FTB by IP
*
* (c) Copyright 2006 by VEN
*
* This file is provided as is (no warranties)
*/

#include <amxmodx>
#include <amxmisc>

#define PLUGIN_NAME "FTB by IP"
#define PLUGIN_VERSION "0.1"
#define PLUGIN_AUTHOR "VEN"

new const g_ftb_cfg_file[] = "ftb.ini"

#define MAX_IPENTRIES 32
new g_ip[MAX_IPENTRIES][16]
new g_ips

#define MAX_PLAYERS 32
new bool:g_alive[MAX_PLAYERS + 1]
new bool:g_ftb[MAX_PLAYERS + 1]

new g_pcvar_ftb

new bool:g_cvar_ftb

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)

	register_event("ResetHUD", "event_hud_reset", "be")
	register_event("DeathMsg", "event_death", "a")
	register_event("Health", "event_dead", "bd", "1=0")

	g_pcvar_ftb = get_cvar_pointer("mp_fadetoblack")

	load_ftb_cfg()
}

public client_putinserver(id) {
	static ip[sizeof g_ip[]], i
	get_user_ip(id, ip, sizeof g_ip[] - 1, _:true)
	for (i = 0; i < g_ips; i++) {
		if (equal(ip, g_ip[i])) {
			g_ftb[id] = true
			return
		}
	}

	g_ftb[id] = false
}

public client_disconnect(id) {
	g_alive[id] = false
}

public event_hud_reset(id) {
	g_alive[id] = true
}

public event_death() {
	new bool:ftb = g_ftb[read_data(2)]
	g_cvar_ftb = bool:get_pcvar_num(g_pcvar_ftb)
	if (!g_cvar_ftb && ftb)
		set_pcvar_num(g_pcvar_ftb, _:true)
}

public event_dead(id) {
	if (g_alive[id]) {
		g_alive[id] = false
		set_pcvar_num(g_pcvar_ftb, _:g_cvar_ftb)
	}
}

load_ftb_cfg() {
	new file[64]
	get_configsdir(file, sizeof file - 1)
	formatex(file, sizeof file - 1, "%s/%s", file, g_ftb_cfg_file)

	if (!file_exists(file)) {
		//log_amx("[%s] ERROR: File ^"%s^" not found!", PLUGIN_NAME, file)
		return
	}

	new string[sizeof g_ip[]], line, len
	while (read_file(file, line++, string, sizeof g_ip[] - 1, len)) {
		if (g_ips == MAX_IPENTRIES) {
			log_amx("[%s] Warning: In process of reading file ^"%s^" defined value ^"MAX_IPENTRIES^" has been reached", PLUGIN_NAME, file)
			return
		}

		if (len && string[0] != ';')
			g_ip[g_ips++] = string
	}
}
